<template>
  <b-dropdown
    ref="refPresetsDropdown"
    class="btn-group dropdown input-group-append w-100 h-100"
    toggle-class="btn rounded-0 p-0"
    variant="none"
    dropdown
    right
    no-caret
    @show="focusPresetsSearch"
  >
    <template #button-content>
      <ListSearchIcon class="text-indigo" />
      <span class="text-indigo d-none d-sm-inline-block">Presets</span>
    </template>
    <treeselect
      ref="refPresetsTreeselect"
      :disable-branch-nodes="true"
      :show-count="true"
      placeholder="Search for a preset..."
      no-results-text="No presets found"
      clear-value-text="Clear selection"
      no-options-text="No presets available"
      no-children-text="No presets"
      :always-open="true"
      :close-on-select="true"
      :auto-focus="true"
      :normalizer="nodeNormalizer"
      search-nested
      open-direction="below"
      :max-height="300"
      :options="getPresetsTree()"
      @select="setPreset"
    >
      <label
        slot="option-label"
        slot-scope="{
          node,
          shouldShowCount,
          count,
          labelClassName,
          countClassName,
        }"
        :class="
          'text-' + node.raw.color + ' font-weight-bold ' + labelClassName
        "
      >
        <b-container class="m-0 p-0" fluid>
          <b-row no-gutters>
            <b-col class="mr-2 text-truncate">
              <template v-if="!node.raw?.query">
                <component
                  :is="node.raw.icon + '-icon'"
                  class="icon-xxs mr-1"
                /><span style="font-size: 0.9em">{{ node.label }}</span>
              </template>
              <template v-else>
                <span
                  style="margin-bottom: 3px"
                  class="avatar bg-indigo-lt avatar-xs p-0 ml-1 mr-1"
                  >{{ node.id.split('-').pop() }}</span
                ><span style="font-size: 0.8em">{{ node.label }}</span>
              </template>
              <span v-if="shouldShowCount" :class="countClassName"
                >({{ count }})</span
              >
            </b-col>
          </b-row>
          <b-row no-gutters>
            <template v-if="!node.raw?.query">
              <b-col
                style="font-size: 0.9em; margin-left: 1.3em; line-height: 1.3"
                class="mr-2"
              >
                <span class="small font-italic text-wrap text-muted">
                  {{ node.raw.description }}
                </span>
              </b-col>
            </template>
            <template v-else>
              <b-col
                style="font-size: 0.9em; margin-left: 2em; line-height: 1.3"
                class="mr-2 d-flex justify-content-between"
              >
                <span class="small font-italic text-wrap text-muted">
                  {{ node.raw.description }}
                </span>
              </b-col>
            </template>
          </b-row>
        </b-container>
      </label>
      <div slot="value-label" slot-scope="{ node }">
        <component :is="node.raw.icon + '-icon'" class="icon-xxs mr-1" />
        {{ node.label }}
      </div>
    </treeselect>
  </b-dropdown>
</template>
<script>
import Treeselect from '@riophae/vue-treeselect';
import { BDropdown } from 'bootstrap-vue';
import '@riophae/vue-treeselect/dist/vue-treeselect.css';
import { mapGetters } from 'vuex';
import notificationsMixin from '~/mixins/notifications.js';
export default {
  components: { Treeselect, BDropdown },
  mixins: [notificationsMixin],
  props: {
    rsmlInputParameter: {
      type: Object,
      default: () => {},
    },
    loadQueryString: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {};
  },
  computed: {
    ...mapGetters({
      userPresets: 'presets/allUserPresets',
    }),
    presets() {
      const presets = this.rsmlInputParameter?.options?.properties?.presets;
      if (this.userPresets.length) {
        this.userPresets.map((preset) => {
          preset.options = {
            properties: { query: JSON.parse(preset.query) },
          };
          const sources =
            this.rsmlInputParameter?.options?.properties?.datasets?.sources;
          if (sources) {
            preset.tags = {
              sources: [Object.keys(sources)[0]],
            };
          }
          return preset;
        });
        presets.user.options.properties.items.data = this.userPresets;
      } else {
        presets.user.options.properties.items.data = [];
      }
      return presets;
    },
  },
  methods: {
    nodeNormalizer(node) {
      return {
        children: node.children && node.children.length ? node.children : 0,
      };
    },
    focusPresetsSearch() {
      this.$nextTick(() => {
        const input = this.$refs.refPresetsTreeselect?.$el?.querySelector(
          '.vue-treeselect__input'
        );
        if (input) {
          input.focus();
          input.select();
        }
      });
    },
    hideDropdown() {
      this.$refs.refPresetsDropdown.hide();
    },
    setPreset(node) {
      this.$refs.refPresetsTreeselect.clear();
      if (node?.query) {
        this.$nuxt.context.store.commit(
          'presets/setUserPreset',
          node.id.startsWith('user') ? node : null
        );
        this.loadQueryString(node.query);
        this.$nextTick(() => {
          this.hideDropdown();
        });
      }
    },
    getPresetsTree() {
      const datasetsSources =
        this.rsmlInputParameter?.options?.properties?.datasets?.sources;
      // presets are only available for its related sources, if no sources
      // are used, no presets must be shown
      if (!datasetsSources) return [];
      const presetsTree = [];
      for (const [presetCategoryKey, presetCategoryProp] of Object.entries(
        this.presets
      )) {
        let categoryNode = presetsTree.find((s) => s.id === presetCategoryKey);
        if (!categoryNode) {
          categoryNode = {
            id: presetCategoryKey,
            label: presetCategoryProp.title,
            icon: presetCategoryProp?.tags?.icon || 'folder-plus',
            color: 'black',
            description: presetCategoryProp.description || '',
            children: [],
          };
          presetsTree.push(categoryNode);
        }
        // get direclty the data instead of fetch it
        const presetData = presetCategoryProp?.options?.properties?.items?.data;
        if (presetData) {
          for (const [presetEntryIndex, presetEntryValue] of Object.entries(
            presetCategoryProp?.options?.properties?.items?.data
          )) {
            // query is mandatory
            const presetNodeQuery =
              presetEntryValue?.options?.properties?.query;
            if (!presetNodeQuery) continue;
            // get sources that match this preset
            const presetSources = presetEntryValue?.tags?.sources;
            // tags.sources is mandatory
            if (!presetSources || !presetSources.length) continue;
            // only load presets for the current sources
            const presetSourceExists = presetSources.some((entry) =>
              Object.prototype.hasOwnProperty.call(datasetsSources, entry)
            );
            if (!presetSourceExists) continue;
            const presetNodeCount = parseInt(presetEntryIndex) + 1;
            const presetNodeId =
              `${presetCategoryKey}-${presetNodeCount}`.toLowerCase();
            // create the node preset
            const presetNode = {
              id: presetNodeId,
              label: presetEntryValue.title || `Preset ${presetNodeCount}`,
              color: 'indigo',
              icon: 'forms',
              description: presetEntryValue.description || '',
              query: presetNodeQuery,
            };
            if (presetCategoryKey === 'user') {
              presetNode.presetId = presetEntryValue.id;
            }
            categoryNode.children.push(presetNode);
          }
        }
      }
      // we have only a single category, build instead a 2-level menu
      if (presetsTree.length === 1) {
        return presetsTree[0].children;
      }
      return presetsTree;
    },
  },
};
</script>

<style scoped>
.group-ctrl-slot {
  margin-top: 6px;
  margin-bottom: 6px;
}
.vue-treeselect svg {
  fill: none !important;
}
::v-deep .vue-treeselect__single-value {
  color: #7955af !important;
  font-weight: 500;
}
::v-deep .dropdown-menu.dropdown-menu-right {
  padding-top: 0 !important;
  width: 25em !important;
}
::v-deep .vue-treeselect__placeholder {
  margin-left: 3px !important;
  color: #8388a6 !important;
  font-style: italic;
  font-size: 0.8em;
}
::v-deep .vue-treeselect__input {
  color: #7955af !important;
}
</style>
